﻿// DB class
function DB(db_name)
{
  this.db_name = db_name;
  this.tables = [];
  this.relationships = []
}
DB.prototype.get_db_name = function()
{
  return this.db_name;
}
DB.prototype.get_tbls_count = function()
{
  return this.tables.length;
}

DB.prototype.add_table = function(table)
{
  this.tables.push(table);
}
DB.prototype.find_table = function(table)
{
  var result = $.grep(this.tables, function(value) { return value.get_table_name() == table; });
  return (result.length == 1 ? result[0] : null);
}
DB.prototype.delete_table = function(table)
{
  this.tables = $.grep(this.tables, function(value) { return value.get_table_name() != table; });
}
DB.prototype.set_db_name = function(db_name)
{
  this.db_name = db_name;
}
DB.prototype.get_all_tables = function()
{
  return this.tables;
}
DB.prototype.show_all_tables = function()
{
  for(j in this.tables)
  {
    alert(this.tables[j].get_table_name());
  }
}
DB.prototype.add_relationship = function(relationship)
{
  this.relationships.push(relationship);
}
DB.prototype.get_all_relationships = function()
{
  return this.relationships;
}
// Table class
function Table(table_name)
{
  this.table_name = table_name;
  this.attributes = [];
}
Table.prototype.get_table_name = function()
{
  return this.table_name;
}
Table.prototype.add_attribute = function(attribute)
{
  this.attributes.push(attribute);
}
Table.prototype.find_attribute = function(attribute)
{
  var result = $.grep(this.attributes, function(value) { return value.get_field_name() == attribute });
  return (result.length == 1 ? result[0] : null);
}
Table.prototype.delete_attribute = function(attribute)
{
  this.attributes = $.grep(this.attributes, function(value) { return value.get_field_name() != attribute });
}
Table.prototype.get_all_attributes = function()
{
  return this.attributes;
}
Table.prototype.set_table_name = function(table_name)
{
  this.table_name = table_name;
}
// Attribute class
function Attribute(field_name,field_type,field_value,index_type,auto_increment)
{
  this.field_name = field_name;
  this.field_type = field_type;
  this.field_value = field_value;
  this.index_type = index_type;
  this.auto_increment = auto_increment;
}
Attribute.prototype.get_field_name = function()
{
  return this.field_name;
}
Attribute.prototype.get_field_type = function()
{
  return this.field_type;
}
Attribute.prototype.get_field_value = function()
{
  return this.field_value;
}
Attribute.prototype.get_index_type = function()
{
  return this.index_type;
}
Attribute.prototype.get_auto_increment = function()
{
  return this.auto_increment;
}
Attribute.prototype.to_string = function()
{
  return this.field_name + ', '+this.field_type+', '+this.field_value+', '+this.index_type+', '+this.auto_increment;
}
Attribute.prototype.set_field_name = function(field_name)
{
  this.field_name = field_name;
}
Attribute.prototype.set_field_type = function(field_type)
{
  this.field_type = field_type;
}
Attribute.prototype.set_field_value = function(field_value)
{
  this.field_value = field_value;
}
Attribute.prototype.set_index_type = function(index_type)
{
  this.index_type = index_type;
}
Attribute.prototype.set_auto_increment = function(auto_increment)
{
  this.auto_increment = auto_increment;
}
// Table relationship object
function Relationship(tbl_a, tbl_b, fk_a, pk_b)
{
  this.source_tbl = tbl_a;
  this.dest_tbl = tbl_b;
  this.source_key = fk_a;
  this.dest_key = pk_b;
}
Relationship.prototype.get_source_tbl = function()
{
  return this.source_tbl;
}
Relationship.prototype.get_dest_tbl = function()
{
  return this.dest_tbl;
}
Relationship.prototype.get_source_key = function()
{
  return this.source_key;
}
Relationship.prototype.get_dest_key = function()
{
  return this.dest_key;
}
// DB class
function DB(db_name)
{
  this.db_name = db_name;
  this.tables = [];
  this.relationships = []
}
DB.prototype.get_db_name = function()
{
  return this.db_name;
}
DB.prototype.get_tbls_count = function()
{
  return this.tables.length;
}

DB.prototype.add_table = function(table)
{
  this.tables.push(table);
}
DB.prototype.find_table = function(table)
{
  var result = $.grep(this.tables, function(value) { return value.get_table_name() == table; });
  return (result.length == 1 ? result[0] : null);
}
DB.prototype.delete_table = function(table)
{
  this.tables = $.grep(this.tables, function(value) { return value.get_table_name() != table; });
}
DB.prototype.set_db_name = function(db_name)
{
  this.db_name = db_name;
}
DB.prototype.get_all_tables = function()
{
  return this.tables;
}
DB.prototype.show_all_tables = function()
{
  for(j in this.tables)
  {
    alert(this.tables[j].get_table_name());
  }
}
DB.prototype.add_relationship = function(relationship)
{
  this.relationships.push(relationship);
}
DB.prototype.get_all_relationships = function()
{
  return this.relationships;
}
// Table class
function Table(table_name)
{
  this.table_name = table_name;
  this.attributes = [];
}
Table.prototype.get_table_name = function()
{
  return this.table_name;
}
Table.prototype.add_attribute = function(attribute)
{
  this.attributes.push(attribute);
}
Table.prototype.find_attribute = function(attribute)
{
  var result = $.grep(this.attributes, function(value) { return value.get_field_name() == attribute });
  return (result.length == 1 ? result[0] : null);
}
Table.prototype.delete_attribute = function(attribute)
{
  this.attributes = $.grep(this.attributes, function(value) { return value.get_field_name() != attribute });
}
Table.prototype.get_all_attributes = function()
{
  return this.attributes;
}
Table.prototype.set_table_name = function(table_name)
{
  this.table_name = table_name;
}
// Attribute class
function Attribute(field_name,field_type,field_value,index_type,auto_increment)
{
  this.field_name = field_name;
  this.field_type = field_type;
  this.field_value = field_value;
  this.index_type = index_type;
  this.auto_increment = auto_increment;
}
Attribute.prototype.get_field_name = function()
{
  return this.field_name;
}
Attribute.prototype.get_field_type = function()
{
  return this.field_type;
}
Attribute.prototype.get_field_value = function()
{
  return this.field_value;
}
Attribute.prototype.get_index_type = function()
{
  return this.index_type;
}
Attribute.prototype.get_auto_increment = function()
{
  return this.auto_increment;
}
Attribute.prototype.to_string = function()
{
  return this.field_name + ', '+this.field_type+', '+this.field_value+', '+this.index_type+', '+this.auto_increment;
}
Attribute.prototype.set_field_name = function(field_name)
{
  this.field_name = field_name;
}
Attribute.prototype.set_field_type = function(field_type)
{
  this.field_type = field_type;
}
Attribute.prototype.set_field_value = function(field_value)
{
  this.field_value = field_value;
}
Attribute.prototype.set_index_type = function(index_type)
{
  this.index_type = index_type;
}
Attribute.prototype.set_auto_increment = function(auto_increment)
{
  this.auto_increment = auto_increment;
}
// Table relationship object
function Relationship(tbl_a, tbl_b, fk_a, pk_b)
{
  this.source_tbl = tbl_a;
  this.dest_tbl = tbl_b;
  this.source_key = fk_a;
  this.dest_key = pk_b;
}
Relationship.prototype.get_source_tbl = function()
{
  return this.source_tbl;
}
Relationship.prototype.get_dest_tbl = function()
{
  return this.dest_tbl;
}
Relationship.prototype.get_source_key = function()
{
  return this.source_key;
}
Relationship.prototype.get_dest_key = function()
{
  return this.dest_key;
}
